Subject: Re: bug#69480: Emacs Lisp needs, for its great 'native-compile', 'declare' and 'the' for fixnums and arrays.

From: Eli Zaretskii <[email-masked]>
Date: Fri, 01 Mar 2024 15:41:24 +0200

> From: Stephen Berman <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked],
>   [email-masked]
> Date: Fri, 01 Mar 2024 14:07:50 +0100
> 
> On Fri, 01 Mar 2024 14:45:39 +0200 Eli Zaretskii <[email-masked]> wrote:
> 
> >> It's still slower with native compilation than with byte compilation on
> >> my machine, unlike on yours.  Do you have any idea why?
> >
> > Maybe your system takes time to allocate memory?  This program
> > allocates almost 850MB of memory on my system, so maybe yours starts
> > paging?
> 
> I see a similar allocation, but I have 16 GB of RAM (~12 of which were
> free when I ran the benchmark), so I think that shouldn't be an issue.
> 
> > Anyway, profiling could give some hints.
> 
> That says almost all memory and CPU are consumed by `build-sieve':

This is skewed, use cpu profiling instead of "memory" profiling.

> But I don't see how that bears on the difference between native and byte
> compilation in my timings versus yours and Andrea's.

My suggestion was to compare profiles in the byte-compiled and
native-compiled cases.

Btw, are you running both cases in the same session?  If so, don't:
restart Emacs and run the other case instead.